<?php

namespace Formulaic;

trait QueryHelper
{
    public function offsetGet($index)
    {
        foreach ((array)$this as $element) {
            if ($element->name() == $index) {
                return $element;
            }
            if ($element instanceof Label
                && $element->getElement()->name() == $index
            ) { 
                return $element;
            }
            if ($element instanceof Element\Group && isset($element[$index])) {
                return $element[$index];
            }
        }
    }

    public function offsetSet($index, $newvalue)
    {
        if (!isset($index)) {
            $index = count((array)$this);
        }
        if (isset($this->attributes['id'])) {
            $newvalue->prefix($this->attributes['id']);
        }
        parent::offsetSet($index, $newvalue);
    }
    
    public function append($newvalue)
    {
        $index = count((array)$this);
        return $this->offsetSet($index, $newvalue);
    }
}

